###################################################
### chunk number 1: 
###################################################
#line 81 "d:/Rcompile/CRANpkg/local/2.12/TSP/inst/doc/TSP.Rnw"
options(width = 75)
### for sampling
set.seed(1234)


###################################################
### chunk number 2: 
###################################################
#line 645 "d:/Rcompile/CRANpkg/local/2.12/TSP/inst/doc/TSP.Rnw"
library("TSP")
data("USCA50")
USCA50


###################################################
### chunk number 3: 
###################################################
#line 661 "d:/Rcompile/CRANpkg/local/2.12/TSP/inst/doc/TSP.Rnw"
set.seed(1234)


###################################################
### chunk number 4: dotchart_USCA50
###################################################
#line 666 "d:/Rcompile/CRANpkg/local/2.12/TSP/inst/doc/TSP.Rnw"
methods <- c("nearest_insertion", "farthest_insertion", "cheapest_insertion",
    "arbitrary_insertion", "nn", "repetitive_nn", "2-opt")

tours <- sapply(methods, FUN = function(m) solve_TSP(USCA50, method = m),
                simplify = FALSE)         
## names(tours) <- methods
## tours$concorde  <- solve_TSP(tsp, method = "concorde")
## tours$concorde  <- solve_TSP(tsp, method = "linkern")

tours[[1]]


## opt <- 14497
dotchart(c(sapply(tours, FUN = attr, "tour_length"), optimal = 14497), 
xlab = "tour length", xlim = c(0, 20000))
## add optimum
#abline(v = opt, col = "red")
#mtext("optimum", at = opt, side = 3, col = "red")


###################################################
### chunk number 5: 
###################################################
#line 710 "d:/Rcompile/CRANpkg/local/2.12/TSP/inst/doc/TSP.Rnw"
set.seed(1234)


###################################################
### chunk number 6: 
###################################################
#line 714 "d:/Rcompile/CRANpkg/local/2.12/TSP/inst/doc/TSP.Rnw"
library("TSP")
data("USCA312")
tsp <- insert_dummy(USCA312, label = "cut")
tsp


###################################################
### chunk number 7: 
###################################################
#line 724 "d:/Rcompile/CRANpkg/local/2.12/TSP/inst/doc/TSP.Rnw"
tour <- solve_TSP(tsp, method="farthest_insertion")
#tour <- solve_TSP(tsp, method ="concorde")
tour


###################################################
### chunk number 8: 
###################################################
#line 736 "d:/Rcompile/CRANpkg/local/2.12/TSP/inst/doc/TSP.Rnw"
path <- cut_tour(tour, "cut")
head(labels(path))
tail(labels(path))


###################################################
### chunk number 9: map1
###################################################
#line 747 "d:/Rcompile/CRANpkg/local/2.12/TSP/inst/doc/TSP.Rnw"
library("maps")
library("sp")
library("maptools")

data("USCA312_map")

plot_path <- function(path){
    plot(as(USCA312_coords, "Spatial"), axes = TRUE)
    plot(USCA312_basemap, add = TRUE, col = "gray")
    points(USCA312_coords, pch = 3, cex = 0.4, col = "red")
    
    path_line <- SpatialLines(list(Lines(list(Line(USCA312_coords[path,])),
	ID="1")))
    plot(path_line, add=TRUE, col = "black")
    points(USCA312_coords[c(head(path,1), tail(path,1)),], pch = 19, 
        col = "black")
}

plot_path(path)


###################################################
### chunk number 10: 
###################################################
#line 802 "d:/Rcompile/CRANpkg/local/2.12/TSP/inst/doc/TSP.Rnw"
set.seed(1234)


###################################################
### chunk number 11: 
###################################################
#line 806 "d:/Rcompile/CRANpkg/local/2.12/TSP/inst/doc/TSP.Rnw"
atsp <- as.ATSP(USCA312)
ny <- which(labels(USCA312) == "New York, NY")
atsp[, ny] <- 0
initial_tour <- solve_TSP(atsp, method="nn")
initial_tour
tour <- solve_TSP(atsp, method ="2-opt", control = list(tour = initial_tour))
tour
path <- cut_tour(tour, ny, exclude_cut = FALSE)

head(labels(path))
tail(labels(path))


###################################################
### chunk number 12: map2
###################################################
#line 819 "d:/Rcompile/CRANpkg/local/2.12/TSP/inst/doc/TSP.Rnw"
plot_path(path)


###################################################
### chunk number 13: 
###################################################
#line 841 "d:/Rcompile/CRANpkg/local/2.12/TSP/inst/doc/TSP.Rnw"
tsp <- reformulate_ATSP_as_TSP(atsp)
tsp


###################################################
### chunk number 14:  eval=FALSE
###################################################
## #line 855 "d:/Rcompile/CRANpkg/local/2.12/TSP/inst/doc/TSP.Rnw"
## #tour <- solve_TSP(tsp, method = "linkern")
## tour <- solve_TSP(tsp, method = "concorde")
## tour <- as.TOUR(tour[tour <= n_of_cities(atsp)])


###################################################
### chunk number 15: 
###################################################
#line 880 "d:/Rcompile/CRANpkg/local/2.12/TSP/inst/doc/TSP.Rnw"
set.seed(1234)


###################################################
### chunk number 16: 
###################################################
#line 884 "d:/Rcompile/CRANpkg/local/2.12/TSP/inst/doc/TSP.Rnw"
m <- as.matrix(USCA312)
ny <- which(labels(USCA312) == "New York, NY")
la <- which(labels(USCA312) == "Los Angeles, CA")

atsp <- ATSP(m[-c(ny,la), -c(ny,la)])
atsp <- insert_dummy(atsp, label = "LA/NY")

la_ny <- which(labels(atsp) == "LA/NY")
atsp[la_ny, ] <- c(m[-c(ny,la), ny], 0)
atsp[, la_ny] <- c(m[la, -c(ny,la)], 0)


###################################################
### chunk number 17: 
###################################################
#line 899 "d:/Rcompile/CRANpkg/local/2.12/TSP/inst/doc/TSP.Rnw"
tour <- solve_TSP(atsp, method ="nearest_insertion")
tour

path_labels <- c("New York, NY", 
    labels(cut_tour(tour, la_ny)), "Los Angeles, CA")
path_ids <- match(path_labels, labels(USCA312))

head(path_labels)
tail(path_labels)


###################################################
### chunk number 18: map3
###################################################
#line 910 "d:/Rcompile/CRANpkg/local/2.12/TSP/inst/doc/TSP.Rnw"
plot_path(path_ids)


###################################################
### chunk number 19: 
###################################################
#line 952 "d:/Rcompile/CRANpkg/local/2.12/TSP/inst/doc/TSP.Rnw"
set.seed(4444)


###################################################
### chunk number 20: 
###################################################
#line 955 "d:/Rcompile/CRANpkg/local/2.12/TSP/inst/doc/TSP.Rnw"
data("iris")
tsp <- TSP(dist(iris[-5]), labels = iris[, "Species"])
#tsp <- TSP(dist(scale(iris[-5])))
tsp_dummy <- insert_dummy(tsp, n = 3, label = "boundary")
tour <- solve_TSP(tsp_dummy)


###################################################
### chunk number 21: clustering
###################################################
#line 970 "d:/Rcompile/CRANpkg/local/2.12/TSP/inst/doc/TSP.Rnw"
## plot the distance matrix
image(tsp_dummy, tour, xlab = "objects", ylab ="objects")

## draw lines where the dummy cities are located
abline(h = which(labels(tour)=="boundary"), col = "red")
abline(v = which(labels(tour)=="boundary"), col = "red")


###################################################
### chunk number 22: 
###################################################
#line 998 "d:/Rcompile/CRANpkg/local/2.12/TSP/inst/doc/TSP.Rnw"
## labels(tour)
#as.vector(abbreviate(labels(tour), dot = TRUE))
out <- rle(labels(tour))
data.frame(Species = out$values, 
           Lenghts = out$lengths, 
           Pos = cumsum(out$lengths))

## do Concorde
# tour <- solve_TSP(tsp_dummy, method = "concorde")
# labels(tour)


###################################################
### chunk number 23: clustering2
###################################################
#line 1023 "d:/Rcompile/CRANpkg/local/2.12/TSP/inst/doc/TSP.Rnw"
prc <- prcomp(iris[1:4])
plot(prc$x, pch = as.numeric(iris[,5]), col =  as.numeric(iris[,5]))

indices <- c(tour, tour[1])
indices[indices > 150] <- NA
lines(prc$x[indices,])


